shader = love.graphics.newShader([[
    extern float depth;
    varying vec4 vpos;
    
    #ifdef VERTEX
    vec4 position(mat4 transform_projection, vec4 vertex_position)
    {
        vpos = transform_projection * vertex_position;
        vpos.z = depth;
        return vpos;
    }
    #endif
    #ifdef PIXEL
    
    void effect()
    {
        love_Canvases[0] = VaryingColor;
    }
    
    #endif
]])

depthBuffer = love.graphics.newCanvas(1000, 1000, { format = "depth16", readable = true })
renderTarget1 = love.graphics.newCanvas(1000, 1000, { format = "normal", readable = true })

function love.update()
    
end

function love.draw()
	love.graphics.setCanvas({ renderTarget1, depthstencil = depthBuffer })
	love.graphics.clear(0.4, 0.4, 1.0, 0.0)
	
	love.graphics.setShader(shader)
	shader:send("depth", 1.0)
	love.graphics.setDepthMode("less", true)
	
	shader:send("depth", 0.5)
	love.graphics.setColor(1.0, 0.0, 0.0, 1.0)
	love.graphics.rectangle("fill", 200, 200, 100, 100)
	
	shader:send("depth", 0.8)
	love.graphics.setColor(0.0, 1.0, 0.0, 1.0)
	love.graphics.rectangle("fill", 250, 250, 100, 100)
	
	love.graphics.reset()
	
	love.graphics.draw(renderTarget1)
	love.graphics.draw(depthBuffer, 0, 0, 0, 0.1, 0.1)
end